
;  GNU C 2.7.2 [AL 1.1, MM 40] RISC NEWS-OS compiled by CC

;  Cc1 defaults:
;  -mmemcpy

;  Cc1 arguments (-G value = 0, Cpu = 3000, ISA = 1):
;  -quiet -dumpbase -O2 -Wall -o

gcc2_compiled.:
__gnu_compiled_c:
; APP
	
	.code
	.align 1
	.global z80_internal_read
z80_internal_read:
	add %r12, %r13
	ext	0x40		; 	xld.ub %r10, [%r12+64]
	ld.ub	%r10,[%r12]
	ret

	
	.code
	.align 1
	.global z80_internal_write
z80_internal_write:
	add %r12, %r13
	ext	0x40		; 	xld.b [%r12+64], %r14
	ld.b	[%r12],%r14
	ret

	
	.code
	.align 1
	.global z80_run
z80_run:
	pushn %r3
	sub	%sp,0x1		; 	xsub %sp, %sp, 4
	;
	ld.w %r0, %r12			; z80
	ext	0x30		; 	xld.w %r3, [%r0+48]		; z80->read
	ld.w	%r3,[%r0]
	ext	0x24		; 	xld.w [%r0+36], %r13		; CYCLE
	ld.w	[%r0],%r13
	cmp	%r13,0x0	; 	xcmp %r13, 0			; if(CYCLE <= 0) break
	jrle	z80_run_L50	; 	xjrle z80_run_L50
	;
z80_run_L10:
	ext	0x23		; 	xld.ub %r10, [%r0+35]		; if(HALT) break
	ld.ub	%r10,[%r0]
	cmp	%r10,0x0	; 	xcmp %r10, 0
	jrne	z80_run_L50	; 	xjrne z80_run_L50
	;
	ext	0x16		; 	xld.uh %r1, [%r0+22]		; PC
	ld.uh	%r1,[%r0]
	;
	ld.w %r12, %r0			; code = z80->read(z80, PC++)
	ld.uh %r13, %r1
	call.d %r3
	add %r1, 1			; *delay*
	ld.ub %r13, %r10
	;
	ext	z80_op_table+0x0@h	; 	xld.w %r2, z80_op_table		; op = &z80_op_table[code]
	ext	z80_op_table+0x0@m
	ld.w	%r2,z80_op_table+0x0@l
	sll	%r10,0x3	; 	xsll %r10, 3
	add %r2, %r10
	;
	ext	0x4		; 	xld.ub %r10, [%r2+4]		; argc == 0 ?
	ld.ub	%r10,[%r2]
	cmp	%r10,0x0	; 	xcmp %r10, 0	
	jreq	z80_run_L20	; 	xjreq z80_run_L20
	ld.b	[%sp+0x0],%r13	; 	xld.b [%sp+0], %r13		; (save code)
	;
	ld.w %r12, %r0			; arg1 = z80->read(z80, PC++)
	ld.uh %r13, %r1
	call.d %r3
	add %r1, 1			; *delay*
	ld.ub %r14, %r10
	;
	ext	0x4		; 	xld.ub %r10, [%r2+4]		; argc == 1 ?
	ld.ub	%r10,[%r2]
	cmp	%r10,0x1	; 	xcmp %r10, 1	
	jreq	z80_run_L30	; 	xjreq z80_run_L30
	ld.b	[%sp+0x1],%r14	; 	xld.b [%sp+1], %r14		; (save arg1)
	;
	ld.w %r12, %r0			; arg2 = z80->read(z80, PC++)
	ld.w %r13, %r1
	call.d %r3
	add %r1, 1			; *delay*
	ld.ub %r15, %r10
	;
	ld.ub	%r14,[%sp+0x1]	; 	xld.ub %r14, [%sp+1]		; (restore arg1)
z80_run_L30:
	ld.ub	%r13,[%sp+0x0]	; 	xld.ub %r13, [%sp+0]		; (restore code)
z80_run_L20:
	;
	ld.w	%r10,[%r2]	; 	xld.w %r10, [%r2+0]		; op->proc(z80, code, arg1, arg2)
	ext	0x16		; 	xld.h [%r0+22], %r1		; PC *anti-interlock*
	ld.h	[%r0],%r1
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	ext	0x24		; 	xld.w %r10, [%r0+36]		; CYCLE -= op->cycle
	ld.w	%r10,[%r0]
	ext	0x5		; 	xld.ub %r11, [%r2+5]
	ld.ub	%r11,[%r2]
	sub %r10, %r11
	ext	0x24		; 	xld.w [%r0+36], %r10
	ld.w	[%r0],%r10
	jrgt	z80_run_L10	; 	xjrgt z80_run_L10		; if(CYCLE <= 0) break
z80_run_L50:
	;
	add	%sp,0x1		; 	xadd %sp, %sp, 4
	popn %r3
	ret

	
	.code
	.align 1
	.global z80op_CB
z80op_CB:
	pushn %r2
	;
	ld.w %r0, %r12			; z80
	ext	0x16		; 	xld.uh %r1, [%r0+22]		; PC
	ld.uh	%r1,[%r0]
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; code = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.uh %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.ub %r13, %r10
	;
	ext	z80_op_table_CB+0x0@h	; 	xld.w %r2, z80_op_table_CB	; op = &z80_op_table_CB[code]
	ext	z80_op_table_CB+0x0@m
	ld.w	%r2,z80_op_table_CB+0x0@l
	sll	%r10,0x3	; 	xsll %r10, 3
	add %r2, %r10
	;
	ld.w	%r10,[%r2]	; 	xld.w %r10, [%r2+0]		; op->proc(z80, code, arg1, arg2)
	ext	0x16		; 	xld.h [%r0+22], %r1		; PC *anti-interlock*
	ld.h	[%r0],%r1
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	ext	0x24		; 	xld.w %r10, [%r0+36]		; CYCLE -= op->cycle
	ld.w	%r10,[%r0]
	ext	0x5		; 	xld.ub %r11, [%r2+5]
	ld.ub	%r11,[%r2]
	sub %r10, %r11
	ext	0x24		; 	xld.w [%r0+36], %r10
	ld.w	[%r0],%r10
	;
	popn %r2
	ret

	
	.code
	.align 1
	.global z80op_ED
z80op_ED:
	pushn %r2
	sub	%sp,0x1		; 	xsub %sp, %sp, 4
	;
	ld.w %r0, %r12			; z80
	ext	0x16		; 	xld.uh %r1, [%r0+22]		; PC
	ld.uh	%r1,[%r0]
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; code = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.uh %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.ub %r13, %r10
	;
	ext	z80_op_table_ED+0x0@h	; 	xld.w %r2, z80_op_table_ED	; op = &z80_op_table_ED[code]
	ext	z80_op_table_ED+0x0@m
	ld.w	%r2,z80_op_table_ED+0x0@l
	sll	%r10,0x3	; 	xsll %r10, 3
	add %r2, %r10
	;
	ext	0x4		; 	xld.ub %r10, [%r2+4]		; argc == 0 ?
	ld.ub	%r10,[%r2]
	cmp	%r10,0x0	; 	xcmp %r10, 0	
	jreq	z80op_ED_L10	; 	xjreq z80op_ED_L10
	ld.b	[%sp+0x0],%r13	; 	xld.b [%sp+0], %r13		; (save code)
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; arg1 = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.uh %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.b	[%sp+0x1],%r10	; 	xld.b [%sp+1], %r10		; (save arg1)
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; arg2 = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.w %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.ub %r15, %r10
	;
	ld.ub	%r14,[%sp+0x1]	; 	xld.ub %r14, [%sp+1]		; (restore arg1)
	ld.ub	%r13,[%sp+0x0]	; 	xld.ub %r13, [%sp+0]		; (restore code)
z80op_ED_L10:
	;
	ld.w	%r10,[%r2]	; 	xld.w %r10, [%r2+0]		; op->proc(z80, code, arg1, arg2)
	ext	0x16		; 	xld.h [%r0+22], %r1		; PC *anti-interlock*
	ld.h	[%r0],%r1
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	ext	0x24		; 	xld.w %r10, [%r0+36]		; CYCLE -= op->cycle
	ld.w	%r10,[%r0]
	ext	0x5		; 	xld.ub %r11, [%r2+5]
	ld.ub	%r11,[%r2]
	sub %r10, %r11
	ext	0x24		; 	xld.w [%r0+36], %r10
	ld.w	[%r0],%r10
	;
	add	%sp,0x1		; 	xadd %sp, %sp, 4
	popn %r2
	ret

	
	.code
	.align 1
	.global z80op_DD
z80op_DD:
	pushn %r2
	sub	%sp,0x1		; 	xsub %sp, %sp, 4
	;
	ld.w %r0, %r12			; z80
	ext	0x16		; 	xld.uh %r1, [%r0+22]		; PC
	ld.uh	%r1,[%r0]
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; code = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.uh %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.ub %r13, %r10
	;
	ext	z80_op_table_DD+0x0@h	; 	xld.w %r2, z80_op_table_DD	; op = &z80_op_table_DD[code]
	ext	z80_op_table_DD+0x0@m
	ld.w	%r2,z80_op_table_DD+0x0@l
	sll	%r10,0x3	; 	xsll %r10, 3
	add %r2, %r10
	;
	ext	0x4		; 	xld.ub %r10, [%r2+4]		; argc == 0 ?
	ld.ub	%r10,[%r2]
	cmp	%r10,0x0	; 	xcmp %r10, 0	
	jreq	z80op_DD_L10	; 	xjreq z80op_DD_L10
	ld.b	[%sp+0x0],%r13	; 	xld.b [%sp+0], %r13		; (save code)
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; arg1 = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.uh %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.ub %r14, %r10
	;
	ext	0x4		; 	xld.ub %r10, [%r2+4]		; argc == 1 ?
	ld.ub	%r10,[%r2]
	cmp	%r10,0x1	; 	xcmp %r10, 1	
	jreq	z80op_DD_L20	; 	xjreq z80op_DD_L20
	ld.b	[%sp+0x1],%r14	; 	xld.b [%sp+1], %r14		; (save arg1)
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; arg2 = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.w %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.ub %r15, %r10
	;
	ld.ub	%r14,[%sp+0x1]	; 	xld.ub %r14, [%sp+1]		; (restore arg1)
z80op_DD_L20:
	ld.ub	%r13,[%sp+0x0]	; 	xld.ub %r13, [%sp+0]		; (restore code)
z80op_DD_L10:
	;
	ld.w	%r10,[%r2]	; 	xld.w %r10, [%r2+0]		; op->proc(z80, code, arg1, arg2)
	ext	0x16		; 	xld.h [%r0+22], %r1		; PC *anti-interlock*
	ld.h	[%r0],%r1
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	ext	0x24		; 	xld.w %r10, [%r0+36]		; CYCLE -= op->cycle
	ld.w	%r10,[%r0]
	ext	0x5		; 	xld.ub %r11, [%r2+5]
	ld.ub	%r11,[%r2]
	sub %r10, %r11
	ext	0x24		; 	xld.w [%r0+36], %r10
	ld.w	[%r0],%r10
	;
	add	%sp,0x1		; 	xadd %sp, %sp, 4
	popn %r2
	ret

	
	.code
	.align 1
	.global z80op_FD
z80op_FD:
	pushn %r2
	sub	%sp,0x1		; 	xsub %sp, %sp, 4
	;
	ld.w %r0, %r12			; z80
	ext	0x16		; 	xld.uh %r1, [%r0+22]		; PC
	ld.uh	%r1,[%r0]
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; code = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.uh %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.ub %r13, %r10
	;
	ext	z80_op_table_FD+0x0@h	; 	xld.w %r2, z80_op_table_FD	; op = &z80_op_table_FD[code]
	ext	z80_op_table_FD+0x0@m
	ld.w	%r2,z80_op_table_FD+0x0@l
	sll	%r10,0x3	; 	xsll %r10, 3
	add %r2, %r10
	;
	ext	0x4		; 	xld.ub %r10, [%r2+4]		; argc == 0 ?
	ld.ub	%r10,[%r2]
	cmp	%r10,0x0	; 	xcmp %r10, 0	
	jreq	z80op_FD_L10	; 	xjreq z80op_FD_L10
	ld.b	[%sp+0x0],%r13	; 	xld.b [%sp+0], %r13		; (save code)
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; arg1 = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.uh %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.ub %r14, %r10
	;
	ext	0x4		; 	xld.ub %r10, [%r2+4]		; argc == 1 ?
	ld.ub	%r10,[%r2]
	cmp	%r10,0x1	; 	xcmp %r10, 1	
	jreq	z80op_FD_L20	; 	xjreq z80op_FD_L20
	ld.b	[%sp+0x1],%r14	; 	xld.b [%sp+1], %r14		; (save arg1)
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; arg2 = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.w %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.ub %r15, %r10
	;
	ld.ub	%r14,[%sp+0x1]	; 	xld.ub %r14, [%sp+1]		; (restore arg1)
z80op_FD_L20:
	ld.ub	%r13,[%sp+0x0]	; 	xld.ub %r13, [%sp+0]		; (restore code)
z80op_FD_L10:
	;
	ld.w	%r10,[%r2]	; 	xld.w %r10, [%r2+0]		; op->proc(z80, code, arg1, arg2)
	ext	0x16		; 	xld.h [%r0+22], %r1		; PC *anti-interlock*
	ld.h	[%r0],%r1
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	ext	0x24		; 	xld.w %r10, [%r0+36]		; CYCLE -= op->cycle
	ld.w	%r10,[%r0]
	ext	0x5		; 	xld.ub %r11, [%r2+5]
	ld.ub	%r11,[%r2]
	sub %r10, %r11
	ext	0x24		; 	xld.w [%r0+36], %r10
	ld.w	[%r0],%r10
	;
	add	%sp,0x1		; 	xadd %sp, %sp, 4
	popn %r2
	ret

	
	.code
	.align 1
	.global z80op_DDCB
z80op_DDCB:
	pushn %r2
	sub	%sp,0x1		; 	xsub %sp, %sp, 4
	;
	ld.w %r0, %r12			; z80
	ext	0x16		; 	xld.uh %r1, [%r0+22]		; PC
	ld.uh	%r1,[%r0]
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; arg1 = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.uh %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.b	[%sp+0x0],%r10	; 	xld.b [%sp+0], %r10		; (save arg1)
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; code = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.uh %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.ub %r13, %r10
	;
	ext	z80_op_table_DDCB+0x0@h	; 	xld.w %r2, z80_op_table_DDCB	; op = &z80_op_table_DDCB[code]
	ext	z80_op_table_DDCB+0x0@m
	ld.w	%r2,z80_op_table_DDCB+0x0@l
	sll	%r10,0x3	; 	xsll %r10, 3
	add %r2, %r10
	;
	ld.ub	%r14,[%sp+0x0]	; 	xld.ub %r14, [%sp+0]		; (restore arg1)
	;
	ld.w	%r10,[%r2]	; 	xld.w %r10, [%r2+0]		; op->proc(z80, code, arg1, arg2)
	ext	0x16		; 	xld.h [%r0+22], %r1		; PC *anti-interlock*
	ld.h	[%r0],%r1
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	ext	0x24		; 	xld.w %r10, [%r0+36]		; CYCLE -= op->cycle
	ld.w	%r10,[%r0]
	ext	0x5		; 	xld.ub %r11, [%r2+5]
	ld.ub	%r11,[%r2]
	sub %r10, %r11
	ext	0x24		; 	xld.w [%r0+36], %r10
	ld.w	[%r0],%r10
	;
	add	%sp,0x1		; 	xadd %sp, %sp, 4
	popn %r2
	ret

	
	.code
	.align 1
	.global z80op_FDCB
z80op_FDCB:
	pushn %r2
	sub	%sp,0x1		; 	xsub %sp, %sp, 4
	;
	ld.w %r0, %r12			; z80
	ext	0x16		; 	xld.uh %r1, [%r0+22]		; PC
	ld.uh	%r1,[%r0]
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; arg1 = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.uh %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.b	[%sp+0x0],%r10	; 	xld.b [%sp+0], %r10		; (save arg1)
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; code = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.uh %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.ub %r13, %r10
	;
	ext	z80_op_table_FDCB+0x0@h	; 	xld.w %r2, z80_op_table_FDCB	; op = &z80_op_table_FDCB[code]
	ext	z80_op_table_FDCB+0x0@m
	ld.w	%r2,z80_op_table_FDCB+0x0@l
	sll	%r10,0x3	; 	xsll %r10, 3
	add %r2, %r10
	;
	ld.ub	%r14,[%sp+0x0]	; 	xld.ub %r14, [%sp+0]		; (restore arg1)
	;
	ld.w	%r10,[%r2]	; 	xld.w %r10, [%r2+0]		; op->proc(z80, code, arg1, arg2)
	ext	0x16		; 	xld.h [%r0+22], %r1		; PC *anti-interlock*
	ld.h	[%r0],%r1
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	ext	0x24		; 	xld.w %r10, [%r0+36]		; CYCLE -= op->cycle
	ld.w	%r10,[%r0]
	ext	0x5		; 	xld.ub %r11, [%r2+5]
	ld.ub	%r11,[%r2]
	sub %r10, %r11
	ext	0x24		; 	xld.w [%r0+36], %r10
	ld.w	[%r0],%r10
	;
	add	%sp,0x1		; 	xadd %sp, %sp, 4
	popn %r2
	ret

	
	.code			; C33(C,V,Z,N) => Z80(S,Z,V,C)
	.global z80_FLAG_CONV	; ====C33====     ====Z80====
z80_FLAG_CONV:			; ----CVZN        SZ---V-C   
	.byte	0x00		; 00000000 00     00000000 00
	.byte	0x80		; 00000001 01     10000000 80
	.byte	0x40		; 00000010 02     01000000 40
	.byte	0xc0		; 00000011 03     11000000 c0
	.byte	0x04		; 00000100 04     00000100 04
	.byte	0x84		; 00000101 05     10000100 84
	.byte	0x44		; 00000110 06     01000100 44
	.byte	0xc4		; 00000111 07     11000100 c4
	.byte	0x01		; 00001000 08     00000001 01
	.byte	0x81		; 00001001 09     10000001 81
	.byte	0x41		; 00001010 0a     01000001 41
	.byte	0xc1		; 00001011 0b     11000001 c1
	.byte	0x05		; 00001100 0c     00000101 05
	.byte	0x85		; 00001101 0d     10000101 85
	.byte	0x45		; 00001110 0e     01000101 45
	.byte	0xc5		; 00001111 0f     11000101 c5

	
	.code
	.align 1
	.global z80_ADD8
z80_ADD8:
	ext	0x1		; 	xld.ub %r14, [%r12+1]			; A
	ld.ub	%r14,[%r12]
	swap %r11, %r13				; *anti-interlock*
	swap %r10, %r14
	add %r10, %r11
	;
	ld.w %r11, %psr				; F(S,Z,V,C)
	and	%r11,0xf	; 	xand %r11, %r11, 0xf
	ext	z80_FLAG_CONV+0x0@h	; 	xld.ub %r11, [%r11+z80_FLAG_CONV]
	ext	z80_FLAG_CONV+0x0@m
	ld.w	%r9,z80_FLAG_CONV+0x0@l
	add	%r9,%r11
	ld.ub	%r11,[%r9]
	;
	swap %r10, %r10				; A
	ext	0x1		; 	xld.b [%r12+1], %r10
	ld.b	[%r12],%r10
	;
	ext	0x0		; 	xand %r10, %r10, 0x28			; F(Y,X)
	and	%r10,0x28
	or %r11, %r10
	;
	and	%r14,0xf	; 	xand %r14, %r14, 0xf			; F(H)
	and	%r13,0xf	; 	xand %r13, %r13, 0xf
	add %r14, %r13
	and	%r14,0x10	; 	xand %r14, %r14, 0x10
	or %r11, %r14
	;
	ld.b	[%r12],%r11	; 	xld.b [%r12+0], %r11			; F
	;
	ret

	
	.code
	.align 1
	.global z80_ADC8
z80_ADC8:
	ld.ub	%r15,[%r12]	; 	xld.ub %r15, [%r12+0]			; F(C)
	ext	0x1		; 	xld.ub %r14, [%r12+1]			; A *anti-interlock*
	ld.ub	%r14,[%r12]
	and	%r15,0x1	; 	xand %r15, %r15, 1
	;
	swap %r10, %r14				; A + n
	swap %r11, %r13
	add %r10, %r11
	;
	ld.w %r11, %psr				; %psr(C1,V1)
	and	%r11,0xc	; 	xand %r11, %r11, 0xc
	;
	swap %r4, %r15				; A + n + c
	add %r10, %r4
	;
	ld.w %r4, %psr				; %psr(C1|C2,V1^V2,Z2,N2)
	ext	0x4		; 	xand %r5, %r4, 0x4
	and	%r5,%r4
	xor %r11, %r5
	and	%r4,0xb		; 	xand %r4, %r4, 0xb
	or %r11, %r4
	ext	z80_FLAG_CONV+0x0@h	; 	xld.ub %r11, [%r11+z80_FLAG_CONV]	; F(S,Z,V,C)
	ext	z80_FLAG_CONV+0x0@m
	ld.w	%r9,z80_FLAG_CONV+0x0@l
	add	%r9,%r11
	ld.ub	%r11,[%r9]
	;
	swap %r10, %r10				; A
	ext	0x1		; 	xld.b [%r12+1], %r10
	ld.b	[%r12],%r10
	;
	ext	0x0		; 	xand %r10, %r10, 0x28			; F(Y,X)
	and	%r10,0x28
	or %r11, %r10
	;
	and	%r14,0xf	; 	xand %r14, %r14, 0xf			; F(H)
	and	%r13,0xf	; 	xand %r13, %r13, 0xf
	add %r14, %r13
	add %r14, %r15
	and	%r14,0x10	; 	xand %r14, %r14, 0x10
	or %r11, %r14
	;
	ld.b	[%r12],%r11	; 	xld.b [%r12+0], %r11			; F
	;
	ret

	
	.code
	.align 1
	.global z80_SUB8
z80_SUB8:
	ext	0x1		; 	xld.ub %r14, [%r12+1]			; A
	ld.ub	%r14,[%r12]
	swap %r11, %r13				; *anti-interlock*
	swap %r10, %r14
	sub %r10, %r11
	;
	ld.w %r11, %psr				; F(S,Z,V,C)
	and	%r11,0xf	; 	xand %r11, %r11, 0xf
	ext	z80_FLAG_CONV+0x0@h	; 	xld.ub %r11, [%r11+z80_FLAG_CONV]
	ext	z80_FLAG_CONV+0x0@m
	ld.w	%r9,z80_FLAG_CONV+0x0@l
	add	%r9,%r11
	ld.ub	%r11,[%r9]
	;
	swap %r10, %r10				; A
	ext	0x1		; 	xld.b [%r12+1], %r10
	ld.b	[%r12],%r10
	;
	ext	0x0		; 	xand %r10, %r10, 0x28			; F(Y,X)
	and	%r10,0x28
	or %r11, %r10
	;
	and	%r14,0xf	; 	xand %r14, %r14, 0xf			; F(H)
	and	%r13,0xf	; 	xand %r13, %r13, 0xf
	sub %r14, %r13
	and	%r14,0x10	; 	xand %r14, %r14, 0x10
	or %r11, %r14
	;
	or	%r11,0x2	; 	xoor %r11, %r11, 2			; F(N)
	;
	ld.b	[%r12],%r11	; 	xld.b [%r12+0], %r11			; F
	;
	ret

	
	.code
	.align 1
	.global z80_SBC8
z80_SBC8:
	ld.ub	%r15,[%r12]	; 	xld.ub %r15, [%r12+0]			; F(C)
	ext	0x1		; 	xld.ub %r14, [%r12+1]			; A *anti-interlock*
	ld.ub	%r14,[%r12]
	and	%r15,0x1	; 	xand %r15, %r15, 1
	;
	swap %r10, %r14				; A - n
	swap %r11, %r13
	sub %r10, %r11
	;
	ld.w %r11, %psr				; %psr(C1,V1)
	and	%r11,0xc	; 	xand %r11, %r11, 0xc
	;
	swap %r4, %r15				; A - n - c
	sub %r10, %r4
	;
	ld.w %r4, %psr				; %psr(C1|C2,V1^V2,Z2,N2)
	ext	0x4		; 	xand %r5, %r4, 0x4
	and	%r5,%r4
	xor %r11, %r5
	and	%r4,0xb		; 	xand %r4, %r4, 0xb
	or %r11, %r4
	ext	z80_FLAG_CONV+0x0@h	; 	xld.ub %r11, [%r11+z80_FLAG_CONV]	; F(S,Z,V,C)
	ext	z80_FLAG_CONV+0x0@m
	ld.w	%r9,z80_FLAG_CONV+0x0@l
	add	%r9,%r11
	ld.ub	%r11,[%r9]
	;
	swap %r10, %r10				; A
	ext	0x1		; 	xld.b [%r12+1], %r10
	ld.b	[%r12],%r10
	;
	ext	0x0		; 	xand %r10, %r10, 0x28			; F(Y,X)
	and	%r10,0x28
	or %r11, %r10
	;
	and	%r14,0xf	; 	xand %r14, %r14, 0xf			; F(H)
	and	%r13,0xf	; 	xand %r13, %r13, 0xf
	sub %r14, %r13
	sub %r14, %r15
	and	%r14,0x10	; 	xand %r14, %r14, 0x10
	or %r11, %r14
	;
	or	%r11,0x2	; 	xoor %r11, %r11, 2			; F(N)
	;
	ld.b	[%r12],%r11	; 	xld.b [%r12+0], %r11			; F
	;
	ret

	
	.code
	.align 1
	.global z80_AND
z80_AND:
	ext	0x1		; 	xld.ub %r10, [%r12+1]		; A
	ld.ub	%r10,[%r12]
	and %r10, %r13			; A & n !INTERLOCK!
	jrne.d	z80_AND_L10	; 	xjrne.d z80_AND_L10
	ld.w %r11, 0x10			; F(H) *delay*
	ext	0x1		; 	xoor %r11, %r11, 0x40		; F(Z)
	or	%r11,0x0
z80_AND_L10:
	ext	0x1		; 	xld.b [%r12+1], %r10		; A
	ld.b	[%r12],%r10
	ext	z80_PARITY+0x0@h	; 	xld.ub %r13, [%r10+z80_PARITY]	; F(P)
	ext	z80_PARITY+0x0@m
	ld.w	%r9,z80_PARITY+0x0@l
	add	%r9,%r10
	ld.ub	%r13,[%r9]
	ext	0x2		; 	xand %r10, %r10, 0xa8		; F(S,Y,X) *anti-interlock*
	and	%r10,0x28
	or %r11, %r13
	or %r11, %r10
	ld.b	[%r12],%r11	; 	xld.b [%r12+0], %r11		; F
	ret

	
	.code
	.align 1
	.global z80_OR
z80_OR:
	ext	0x1		; 	xld.ub %r10, [%r12+1]		; A
	ld.ub	%r10,[%r12]
	or %r10, %r13			; A & n !INTERLOCK!
	jrne.d	z80_OR_L10	; 	xjrne.d z80_OR_L10
	ld.w %r11, 0			; *delay*
	ext	0x1		; 	xoor %r11, %r11, 0x40		; F(Z)
	or	%r11,0x0
z80_OR_L10:
	ext	0x1		; 	xld.b [%r12+1], %r10		; A
	ld.b	[%r12],%r10
	ext	z80_PARITY+0x0@h	; 	xld.ub %r13, [%r10+z80_PARITY]	; F(P)
	ext	z80_PARITY+0x0@m
	ld.w	%r9,z80_PARITY+0x0@l
	add	%r9,%r10
	ld.ub	%r13,[%r9]
	ext	0x2		; 	xand %r10, %r10, 0xa8		; F(S,Y,X) *anti-interlock*
	and	%r10,0x28
	or %r11, %r13
	or %r11, %r10
	ld.b	[%r12],%r11	; 	xld.b [%r12+0], %r11		; F
	ret

	
	.code
	.align 1
	.global z80_XOR
z80_XOR:
	ext	0x1		; 	xld.ub %r10, [%r12+1]		; A
	ld.ub	%r10,[%r12]
	xor %r10, %r13			; A & n !INTERLOCK!
	jrne.d	z80_XOR_L10	; 	xjrne.d z80_XOR_L10
	ld.w %r11, 0			; *delay*
	ext	0x1		; 	xoor %r11, %r11, 0x40		; F(Z)
	or	%r11,0x0
z80_XOR_L10:
	ext	0x1		; 	xld.b [%r12+1], %r10		; A
	ld.b	[%r12],%r10
	ext	z80_PARITY+0x0@h	; 	xld.ub %r13, [%r10+z80_PARITY]	; F(P)
	ext	z80_PARITY+0x0@m
	ld.w	%r9,z80_PARITY+0x0@l
	add	%r9,%r10
	ld.ub	%r13,[%r9]
	ext	0x2		; 	xand %r10, %r10, 0xa8		; F(S,Y,X) *anti-interlock*
	and	%r10,0x28
	or %r11, %r13
	or %r11, %r10
	ld.b	[%r12],%r11	; 	xld.b [%r12+0], %r11		; F
	ret

	
	.code
	.align 1
	.global z80_CP
z80_CP:
	ext	0x1		; 	xld.ub %r14, [%r12+1]			; A
	ld.ub	%r14,[%r12]
	swap %r11, %r13				; *anti-interlock*
	swap %r10, %r14
	cmp %r10, %r11
	;
	ld.w %r11, %psr				; F(S,Z,V,C)
	and	%r11,0xf	; 	xand %r11, %r11, 0xf
	ext	z80_FLAG_CONV+0x0@h	; 	xld.ub %r11, [%r11+z80_FLAG_CONV]
	ext	z80_FLAG_CONV+0x0@m
	ld.w	%r9,z80_FLAG_CONV+0x0@l
	add	%r9,%r11
	ld.ub	%r11,[%r9]
	;
	ext	0x28		; 	xand %r10, %r13, 0x28			; F(Y,X) *anti-interlock*
	and	%r10,%r13
	or %r11, %r10
	;
	and	%r14,0xf	; 	xand %r14, %r14, 0xf			; F(H)
	and	%r13,0xf	; 	xand %r13, %r13, 0xf
	sub %r14, %r13
	and	%r14,0x10	; 	xand %r14, %r14, 0x10
	or %r11, %r14
	;
	or	%r11,0x2	; 	xoor %r11, %r11, 2			; F(N)
	;
	ld.b	[%r12],%r11	; 	xld.b [%r12+0], %r11			; F
	;
	ret

	
	.code
	.align 1
	.global z80_INC8
z80_INC8:
	swap %r10, %r13				; r + 1
	ext	0x20		; 	xadd %r10, %r10, 0x01000000
	ext	0x0
	add	%r10,0x0
	;
	ld.w %r11, %psr				; %psr(V,N,Z)
	and	%r11,0x7	; 	xand %r11, %r11, 0x7
	ext	z80_FLAG_CONV+0x0@h	; 	xld.ub %r11, [%r11+z80_FLAG_CONV]	; F(S,Z,V)
	ext	z80_FLAG_CONV+0x0@m
	ld.w	%r9,z80_FLAG_CONV+0x0@l
	add	%r9,%r11
	ld.ub	%r11,[%r9]
	;
	swap %r10, %r10				; r
	;
	ext	0x28		; 	xand %r14, %r10, 0x28			; F(Y,X)
	and	%r14,%r10
	ld.ub	%r15,[%r12]	; 	xld.ub %r15, [%r12+0]			; F(C)
	or %r11, %r14				; *anti-interlock*
	and	%r15,0x1	; 	xand %r15, %r15, 1
	or %r11, %r15
	;
	and	%r13,0xf	; 	xand %r13, %r13, 0xf			; F(H)
	add	%r13,0x1	; 	xadd %r13, %r13, 1
	and	%r13,0x10	; 	xand %r13, %r13, 0x10
	or %r11, %r13
	;
	ld.b	[%r12],%r11	; 	xld.b [%r12+0], %r11			; F
	;
	ret

	
	.code
	.align 1
	.global z80_DEC8
z80_DEC8:
	swap %r10, %r13				; r - 1
	ext	0x20		; 	xsub %r10, %r10, 0x01000000
	ext	0x0
	sub	%r10,0x0
	;
	ld.w %r11, %psr				; %psr(V,N,Z)
	and	%r11,0x7	; 	xand %r11, %r11, 0x7
	ext	z80_FLAG_CONV+0x0@h	; 	xld.ub %r11, [%r11+z80_FLAG_CONV]	; F(S,Z,V)
	ext	z80_FLAG_CONV+0x0@m
	ld.w	%r9,z80_FLAG_CONV+0x0@l
	add	%r9,%r11
	ld.ub	%r11,[%r9]
	;
	swap %r10, %r10				; r
	;
	ext	0x28		; 	xand %r14, %r10, 0x28			; F(Y,X)
	and	%r14,%r10
	ld.ub	%r15,[%r12]	; 	xld.ub %r15, [%r12+0]			; F(C)
	or %r11, %r14				; *anti-interlock*
	and	%r15,0x1	; 	xand %r15, %r15, 1
	or %r11, %r15
	;
	and	%r13,0xf	; 	xand %r13, %r13, 0xf			; F(H)
	sub	%r13,0x1	; 	xsub %r13, %r13, 1
	and	%r13,0x10	; 	xand %r13, %r13, 0x10
	or %r11, %r13
	;
	or	%r11,0x2	; 	xoor %r11, %r11, 2			; F(N)
	;
	ld.b	[%r12],%r11	; 	xld.b [%r12+0], %r11			; F
	;
	ret

	
	.code
	.align 1
	.global z80_ADD16
z80_ADD16:
	ld.ub	%r11,[%r12]	; 	xld.ub %r11, [%r12+0]			; F(S,Z,V)
	ld.w %r10, %r13				; rr + nn *anti-interlock*
	ext	0x3		; 	xand %r11, %r11, 0xc4
	and	%r11,0x4
	add %r10, %r14
	ld.w	%r15,%r10	; 	xand %r15, %r10, 0xffff0000
	ext	0x1c00
	and	%r15,0x0
	jreq	z80_ADD16_L10	; 	xjreq z80_ADD16_L10
	sub %r10, %r15
	or	%r11,0x1	; 	xoor %r11, %r11, 1			; F(C)
z80_ADD16_L10:
	;
	ld.w %r15, %r10				; F(Y,X)
	srl	%r15,0x8	; 	xsrl %r15, 8
	ext	0x0		; 	xand %r15, %r15, 0x28
	and	%r15,0x28
	or %r11, %r15
	;
	ext	0x3f		; 	xand %r13, %r13, 0xfff			; F(H)
	and	%r13,0x3f
	ext	0x3f		; 	xand %r14, %r14, 0xfff
	and	%r14,0x3f
	add %r13, %r14
	srl	%r13,0x8	; 	xsrl %r13, 8
	and	%r13,0x10	; 	xand %r13, %r13, 0x10
	or %r11, %r13
	;
	ld.b	[%r12],%r11	; 	xld.b [%r12+0], %r11			; F
	;
	ret

	
	.code
	.align 1
	.global z80_ADC16
z80_ADC16:
	ld.ub	%r15,[%r12]	; 	xld.ub %r15, [%r12+0]			; F(C)
	ld.w %r10, %r13
	ld.w %r11, %r14
	and	%r15,0x1	; 	xand %r15, %r15, 1
	;
	sll	%r10,0x8	; 	xsll %r10, 16				; rr + nn
	sll	%r10,0x8
	sll	%r11,0x8	; 	xsll %r11, 16
	sll	%r11,0x8
	add %r10, %r11
	;
	ld.w %r11, %psr				; %psr(C1,V1)
	and	%r11,0xc	; 	xand %r11, %r11, 0xc
	;
	ld.w %r4, %r15				; rr + nn + c
	sll	%r4,0x8		; 	xsll %r4, 16
	sll	%r4,0x8
	add %r10, %r4
	;
	ld.w %r4, %psr				; %psr(C1|C2,V1^V2,Z2,N2)
	ext	0x4		; 	xand %r5, %r4, 0x4
	and	%r5,%r4
	xor %r11, %r5
	and	%r4,0xb		; 	xand %r4, %r4, 0xb
	or %r11, %r4
	ext	z80_FLAG_CONV+0x0@h	; 	xld.ub %r11, [%r11+z80_FLAG_CONV]	; F(S,Z,V,C)
	ext	z80_FLAG_CONV+0x0@m
	ld.w	%r9,z80_FLAG_CONV+0x0@l
	add	%r9,%r11
	ld.ub	%r11,[%r9]
	;
	srl	%r10,0x8	; 	xsrl %r10, 16				; rr
	srl	%r10,0x8
	;
	ld.w %r4, %r10				; F(Y,X)
	srl	%r4,0x8		; 	xsrl %r4, 8
	ext	0x0		; 	xand %r4, %r4, 0x28
	and	%r4,0x28
	or %r11, %r4
	;
	ext	0x3f		; 	xand %r13, %r13, 0xfff			; F(H)
	and	%r13,0x3f
	ext	0x3f		; 	xand %r14, %r14, 0xfff
	and	%r14,0x3f
	add %r13, %r14
	add %r13, %r15
	srl	%r13,0x8	; 	xsrl %r13, 8
	and	%r13,0x10	; 	xand %r13, %r13, 0x10
	or %r11, %r13
	;
	ld.b	[%r12],%r11	; 	xld.b [%r12+0], %r11			; F
	;
	ret

	
	.code
	.align 1
	.global z80_SBC16
z80_SBC16:
	ld.ub	%r15,[%r12]	; 	xld.ub %r15, [%r12+0]			; F(C)
	ld.w %r10, %r13
	ld.w %r11, %r14
	and	%r15,0x1	; 	xand %r15, %r15, 1
	;
	sll	%r10,0x8	; 	xsll %r10, 16				; rr - nn
	sll	%r10,0x8
	sll	%r11,0x8	; 	xsll %r11, 16
	sll	%r11,0x8
	sub %r10, %r11
	;
	ld.w %r11, %psr				; %psr(C1,V1)
	and	%r11,0xc	; 	xand %r11, %r11, 0xc
	;
	ld.w %r4, %r15				; rr - nn - c
	sll	%r4,0x8		; 	xsll %r4, 16
	sll	%r4,0x8
	sub %r10, %r4
	;
	ld.w %r4, %psr				; %psr(C1|C2,V1^V2,Z2,N2)
	ext	0x4		; 	xand %r5, %r4, 0x4
	and	%r5,%r4
	xor %r11, %r5
	and	%r4,0xb		; 	xand %r4, %r4, 0xb
	or %r11, %r4
	ext	z80_FLAG_CONV+0x0@h	; 	xld.ub %r11, [%r11+z80_FLAG_CONV]	; F(S,Z,V,C)
	ext	z80_FLAG_CONV+0x0@m
	ld.w	%r9,z80_FLAG_CONV+0x0@l
	add	%r9,%r11
	ld.ub	%r11,[%r9]
	;
	srl	%r10,0x8	; 	xsrl %r10, 16				; rr
	srl	%r10,0x8
	;
	ld.w %r4, %r10				; F(Y,X)
	srl	%r4,0x8		; 	xsrl %r4, 8
	ext	0x0		; 	xand %r4, %r4, 0x28
	and	%r4,0x28
	or %r11, %r4
	;
	ext	0x3f		; 	xand %r13, %r13, 0xfff			; F(H)
	and	%r13,0x3f
	ext	0x3f		; 	xand %r14, %r14, 0xfff
	and	%r14,0x3f
	sub %r13, %r14
	sub %r13, %r15
	srl	%r13,0x8	; 	xsrl %r13, 8
	and	%r13,0x10	; 	xand %r13, %r13, 0x10
	or %r11, %r13
	;
	or	%r11,0x2	; 	xoor %r11, %r11, 2			; F(N)
	;
	ld.b	[%r12],%r11	; 	xld.b [%r12+0], %r11			; F
	;
	ret

; NO_APP
	.code
	.align	1
	.global	z80_RL
z80_RL:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ld.w	%r10,%r13
	sll	%r10,0x1	; 	xsll	%r10,1
	ld.ub	%r11,[%r12]	; 	xld.ub	%r11,[%r12]
	and	%r11,0x1	; 	xand	%r11,%r11,0x00000001
	or	%r10,%r11
	ld.w	%r15,%r10
	ld.w	%r14,%r10
	ext	0x2		; 	xand	%r14,%r14,0x000000a8
	and	%r14,0x28
	ld.ub	%r10,%r15
	ext	z80_PARITY+0x0@h	; 	xld.ub	%r11,[%r10+z80_PARITY]
	ext	z80_PARITY+0x0@m
	ld.w	%r9,z80_PARITY+0x0@l
	add	%r9,%r10
	ld.ub	%r11,[%r9]
	ld.ub	%r13,%r13
	srl	%r13,0x7	; 	xsrl	%r13,7
	cmp	%r10,0x0
	jrne	__LX27		; 	xjrne	__L27
	ld.w	%r10,%r11
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
	or	%r14,%r10
	ld.w	%r10,%r14
	jp	__LX29		; 	xjp	__L29
__LX27:				; __L27:
	ld.w	%r10,%r14
	or	%r10,%r11
__LX29:				; __L29:
	or	%r10,%r13
	ld.b	[%r12],%r10	; 	xld.b	[%r12],%r10
	ld.ub	%r10,%r15
	ret
	.align	1
	.global	z80_RLC
z80_RLC:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ld.ub	%r11,%r13
	srl	%r11,0x7	; 	xsrl	%r11,7
	sll	%r13,0x1	; 	xsll	%r13,1
	ld.w	%r10,%r11
	or	%r10,%r13
	ld.w	%r15,%r10
	ld.w	%r14,%r10
	ext	0x2		; 	xand	%r14,%r14,0x000000a8
	and	%r14,0x28
	ld.ub	%r10,%r15
	ext	z80_PARITY+0x0@h	; 	xld.ub	%r13,[%r10+z80_PARITY]
	ext	z80_PARITY+0x0@m
	ld.w	%r9,z80_PARITY+0x0@l
	add	%r9,%r10
	ld.ub	%r13,[%r9]
	ld.ub	%r11,%r11
	cmp	%r10,0x0
	jrne	__LX31		; 	xjrne	__L31
	ld.w	%r10,%r13
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
	or	%r14,%r10
	ld.w	%r10,%r14
	jp	__LX33		; 	xjp	__L33
__LX31:				; __L31:
	ld.w	%r10,%r14
	or	%r10,%r13
__LX33:				; __L33:
	or	%r10,%r11
	ld.b	[%r12],%r10	; 	xld.b	[%r12],%r10
	ld.ub	%r10,%r15
	ret
	.align	1
	.global	z80_RR
z80_RR:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ld.ub	%r10,%r13
	srl	%r10,0x1	; 	xsrl	%r10,1
	ld.ub	%r11,[%r12]	; 	xld.ub	%r11,[%r12]
	sll	%r11,0x7	; 	xsll	%r11,7
	or	%r10,%r11
	ld.w	%r15,%r10
	ld.w	%r14,%r10
	ext	0x2		; 	xand	%r14,%r14,0x000000a8
	and	%r14,0x28
	ld.ub	%r10,%r15
	ext	z80_PARITY+0x0@h	; 	xld.ub	%r11,[%r10+z80_PARITY]
	ext	z80_PARITY+0x0@m
	ld.w	%r9,z80_PARITY+0x0@l
	add	%r9,%r10
	ld.ub	%r11,[%r9]
	and	%r13,0x1	; 	xand	%r13,%r13,0x00000001
	cmp	%r10,0x0
	jrne	__LX35		; 	xjrne	__L35
	ld.w	%r10,%r11
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
	or	%r14,%r10
	ld.w	%r10,%r14
	jp	__LX37		; 	xjp	__L37
__LX35:				; __L35:
	ld.w	%r10,%r14
	or	%r10,%r11
__LX37:				; __L37:
	or	%r10,%r13
	ld.b	[%r12],%r10	; 	xld.b	[%r12],%r10
	ld.ub	%r10,%r15
	ret
	.align	1
	.global	z80_RRC
z80_RRC:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ld.ub	%r10,%r13
	srl	%r10,0x1	; 	xsrl	%r10,1
	ld.w	%r11,%r13
	sll	%r11,0x7	; 	xsll	%r11,7
	or	%r10,%r11
	ld.w	%r15,%r10
	ld.w	%r14,%r10
	ext	0x2		; 	xand	%r14,%r14,0x000000a8
	and	%r14,0x28
	ld.ub	%r10,%r15
	ext	z80_PARITY+0x0@h	; 	xld.ub	%r11,[%r10+z80_PARITY]
	ext	z80_PARITY+0x0@m
	ld.w	%r9,z80_PARITY+0x0@l
	add	%r9,%r10
	ld.ub	%r11,[%r9]
	and	%r13,0x1	; 	xand	%r13,%r13,0x00000001
	cmp	%r10,0x0
	jrne	__LX39		; 	xjrne	__L39
	ld.w	%r10,%r11
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
	or	%r14,%r10
	ld.w	%r10,%r14
	jp	__LX41		; 	xjp	__L41
__LX39:				; __L39:
	ld.w	%r10,%r14
	or	%r10,%r11
__LX41:				; __L41:
	or	%r10,%r13
	ld.b	[%r12],%r10	; 	xld.b	[%r12],%r10
	ld.ub	%r10,%r15
	ret
	.align	1
	.global	z80_SLA
z80_SLA:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ld.w	%r10,%r13
	sll	%r10,0x1	; 	xsll	%r10,1
	ld.w	%r15,%r10
	ld.w	%r14,%r10
	ext	0x2		; 	xand	%r14,%r14,0x000000a8
	and	%r14,0x28
	ld.ub	%r10,%r15
	ext	z80_PARITY+0x0@h	; 	xld.ub	%r11,[%r10+z80_PARITY]
	ext	z80_PARITY+0x0@m
	ld.w	%r9,z80_PARITY+0x0@l
	add	%r9,%r10
	ld.ub	%r11,[%r9]
	ld.ub	%r13,%r13
	srl	%r13,0x7	; 	xsrl	%r13,7
	cmp	%r10,0x0
	jrne	__LX43		; 	xjrne	__L43
	ld.w	%r10,%r11
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
	or	%r14,%r10
	ld.w	%r10,%r14
	jp	__LX45		; 	xjp	__L45
__LX43:				; __L43:
	ld.w	%r10,%r14
	or	%r10,%r11
__LX45:				; __L45:
	or	%r10,%r13
	ld.b	[%r12],%r10	; 	xld.b	[%r12],%r10
	ld.ub	%r10,%r15
	ret
	.align	1
	.global	z80_SRA
z80_SRA:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ld.b	%r10,%r13
	sra	%r10,0x1	; 	xsra	%r10,1
	ld.w	%r15,%r10
	ld.w	%r14,%r10
	ext	0x2		; 	xand	%r14,%r14,0x000000a8
	and	%r14,0x28
	ld.ub	%r10,%r15
	ext	z80_PARITY+0x0@h	; 	xld.ub	%r11,[%r10+z80_PARITY]
	ext	z80_PARITY+0x0@m
	ld.w	%r9,z80_PARITY+0x0@l
	add	%r9,%r10
	ld.ub	%r11,[%r9]
	and	%r13,0x1	; 	xand	%r13,%r13,0x00000001
	cmp	%r10,0x0
	jrne	__LX47		; 	xjrne	__L47
	ld.w	%r10,%r11
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
	or	%r14,%r10
	ld.w	%r10,%r14
	jp	__LX49		; 	xjp	__L49
__LX47:				; __L47:
	ld.w	%r10,%r14
	or	%r10,%r11
__LX49:				; __L49:
	or	%r10,%r13
	ld.b	[%r12],%r10	; 	xld.b	[%r12],%r10
	ld.ub	%r10,%r15
	ret
	.align	1
	.global	z80_SRL
z80_SRL:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ld.ub	%r10,%r13
	srl	%r10,0x1	; 	xsrl	%r10,1
	ld.w	%r15,%r10
	ld.w	%r14,%r10
	ext	0x0		; 	xand	%r14,%r14,0x00000028
	and	%r14,0x28
	ld.ub	%r10,%r15
	ext	z80_PARITY+0x0@h	; 	xld.ub	%r11,[%r10+z80_PARITY]
	ext	z80_PARITY+0x0@m
	ld.w	%r9,z80_PARITY+0x0@l
	add	%r9,%r10
	ld.ub	%r11,[%r9]
	and	%r13,0x1	; 	xand	%r13,%r13,0x00000001
	cmp	%r10,0x0
	jrne	__LX51		; 	xjrne	__L51
	ld.w	%r10,%r11
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
	or	%r14,%r10
	ld.w	%r10,%r14
	jp	__LX53		; 	xjp	__L53
__LX51:				; __L51:
	ld.w	%r10,%r14
	or	%r10,%r11
__LX53:				; __L53:
	or	%r10,%r13
	ld.b	[%r12],%r10	; 	xld.b	[%r12],%r10
	ld.ub	%r10,%r15
	ret
	.align	1
	.global	z80_BIT
z80_BIT:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ld.ub	%r13,%r13
	ld.w	%r10,0x1	; 	xld.w	%r10,0x00000001		; 1
	ld.w	%r9,%r13	; 	xsll	%r10,%r13
	and	%r9,0x1f
	cmp	%r9,0x8
	jrle	4
	sll	%r10,0x8
	jp.d	-3
	sub	%r9,0x8
	sll	%r10,%r9
	and	%r14,%r10
	ld.w	%r11,%r14
	ext	0x2		; 	xand	%r11,%r11,0x00000080
	and	%r11,0x0
	ld.ub	%r10,[%r12]	; 	xld.ub	%r10,[%r12]
	and	%r10,0x1	; 	xand	%r10,%r10,0x00000001
	ld.ub	%r14,%r14
	cmp	%r14,0x0
	jreq	__LX55		; 	xjreq	__L55
	or	%r10,0x10	; 	xoor	%r10,%r10,0x00000010
	jp	__LX57		; 	xjp	__L57
__LX55:				; __L55:
	ext	0x1		; 	xoor	%r10,%r10,0x00000054
	or	%r10,0x14
__LX57:				; __L57:
	or	%r11,%r10
	ld.w	%r10,%r11
	ld.b	[%r12],%r10	; 	xld.b	[%r12],%r10
	ret

